Unit IP02R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTIP10_p;

procedure IP02R(var XA :Array of Real; var YA :Array of Real;
                NA :Integer; NP :Integer; X :Real; var Y :Real;
                var DY :Real; var C :Array of Real;
                var D :Array of Real; var IERR :Integer);

implementation

procedure IP02R(var XA :Array of Real; var YA :Array of Real;
                NA :Integer; NP :Integer; X :Real; var Y :Real;
                var DY :Real; var C :Array of Real;
                var D :Array of Real; var IERR :Integer);
var
N,I,NS,N1,M,NM,IM,IN_,IT :Integer;
DIF,DIFT,H0,HP,W,DEN :Real;
const
ZERO :Real = 0.0;
label
_10,_20,_2,_3,_4,_5,_6,_30,_40,_50,_60,_70,_80;
begin
IERR := 0;
N := NP+1;
if ( NA >= N ) 
 then goto _10;
IERR := 66;
UTIP10(IERR,1);
goto _80;
_10:
NS := 1;
DIF := Abs(X-XA[0]);
for I:=1 to NA do
 begin
  DIFT := Abs(X-XA[I-1]);
  if ( DIFT >= DIF ) 
   then goto _20;
  NS := I;
  DIF := DIFT;
_20:
 end;
if ( NS > N/2 ) 
 then goto _2;
IN_ := 1;
goto _5;
_2:
if ( NS+N/2 < NA ) 
 then goto _3;
IN_ := NA-N+1;
goto _5;
_3:
if ( X > XA[NS-1] ) 
 then goto _4;
IN_ := NS-N div 2;
goto _5;
_4:
IN_ := NS-N div 2+1;
_5:
Y := YA[NS-1];
IN_ := IN_-1;
NS := NS-1-IN_;
N1 := N-1;
for I:=1 to N do
 begin
  IT := I+IN_;
  C[I-1] := YA[IT-1];
  D[I-1] := YA[IT-1];
_6:
 end;
for M:=1 to N1 do
 begin
  NM := N-M;
  for I:=1 to NM do
   begin
    IT := IN_+I;
    H0 := XA[IT-1]-X;
    IM := I+M+IN_;
    HP := XA[IM-1]-X;
    W := C[I+0]-D[I-1];
    DEN := H0-HP;
    if ( DEN <> ZERO ) 
     then goto _30;
    IERR := 65;
    UTIP10(IERR,1);
    goto _80;
_30:
    DEN := W/DEN;
    D[I-1] := HP*DEN;
    C[I-1] := H0*DEN;
_40:
   end;
  if ( 2*NS >= NM ) 
   then goto _50;
  DY := C[NS+0];
  goto _60;
_50:
  DY := D[NS-1];
  NS := NS-1;
_60:
  Y := Y+DY;
_70:
 end;
_80:
end;

end.
